
// 重启系统函数，使用resetFunc()调用。
void(* resetFunc) (void) = 0;

// 看门狗中断
ISR(WDT_vect) {
  // MCUSR   = (1<<WDRF); // 这里设置看门狗重启标记无效，因为MCUSR只能置0不能置1
  WDTCSR |= (1<<WDCE) | (1<<WDE); // 允许设置看门狗
  WDTCSR  = 0; // 取消看门狗（系统软重启之前不会自动清除看门狗，所以必须手工清理）
  Serial.println("******");
  resetFunc();
}

void setup() {
  Serial.begin(9600);
  delay(100);
  if ((MCUSR & B0001) == B0001) {
    Serial.println("Reset by [Power-on]");
  } else if ((MCUSR & B0010) == B0010) {
    Serial.println("Reset by [External]");
  } else if ((MCUSR & B0100) == B0100) {
    Serial.println("Reset by [Brown-out]");
  } else if ((MCUSR & B1000) == B1000) {
    Serial.println("Reset by [Watchdog]");
  }
  Serial.println("Watchdog enabled!");

  byte TIME = B1000; // 超时时间
  WDTCSR |= (1<<WDCE) | (1<<WDE); // 允许设置看门狗
  WDTCSR  = (1<<WDIE) | ((TIME & B1000) << 2 | (TIME & B0111)); // 设置为仅中断模式
}

uint8_t timer = 0;
void loop() {
  if (!(millis() % 1000)) {
    Serial.print(millis());
    Serial.print("--");
    timer++;
    Serial.println(timer);
    delay(1);
  }
  // __asm__ __volatile__ ("wdr"); // 复位看门狗计数器
}
